#pragma once

#include "network/TCPListener.h"
#include "Protocol.h"
#include "NetworkMessage.h"

namespace Feather
{
    class MinecraftClient
    {
    public:
        MinecraftClient(Network::TCPClient&& client);
        ~MinecraftClient();

        inline Network::TCPClient& GetTCPClient() { return m_client; }
        inline ProtocolContext& GetContext() { return m_context; }

        void SendMessage(const NetworkMessage& message);

    private:
        Network::TCPClient m_client;
        ProtocolContext    m_context;
    };
}